<!--
  -    Copyright (c) 2018-2025, lengleng All rights reserved.
  -
  - Redistribution and use in source and binary forms, with or without
  - modification, are permitted provided that the following conditions are met:
  -
  - Redistributions of source code must retain the above copyright notice,
  - this list of conditions and the following disclaimer.
  - Redistributions in binary form must reproduce the above copyright
  - notice, this list of conditions and the following disclaimer in the
  - documentation and/or other materials provided with the distribution.
  - Neither the name of the pig4cloud.com developer nor the names of its
  - contributors may be used to endorse or promote products derived from
  - this software without specific prior written permission.
  - Author: lengleng (wangiegie@gmail.com)
  -->
<template>
  <div class="execution">
    <basic-container>
      <avue-crud ref="crud"
                 :page.sync="page"
                 :data="tableData"
                 :table-loading="tableLoading"
                 :before-open="beforeOpen"
                 :option="tableOption"
                 @on-load="getList"
                 @search-change="searchChange"
                 @refresh-change="refreshChange"
                 @size-change="sizeChange"
                 @current-change="currentChange"
                 @row-update="handleUpdate"
                 @row-save="handleSave"
                 @row-del="rowDel">
<!--        <template slot-scope="scope" slot="menuRight">-->
<!--          <el-button type="warning"-->
<!--                     icon="el-icon-refresh"-->
<!--                     size="small"-->
<!--                     plain-->
<!--                     @click.stop="syncStation()">同步-->
<!--          </el-button>-->
<!--        </template>-->
        <template slot='forecastManufactor' slot-scope="scope">
          <span>{{ formatForecastmanufactor(scope.row) }}</span>
        </template>
        <template slot='belongForecastManufactor' slot-scope="scope">
          <span>{{ formatbelongForecastManufactor(scope.row) }}</span>
        </template>
        <template slot="menu" slot-scope="{ row, index }">
          <el-button type="primary" size="small" icon="el-icon-edit" class="myButton"
                     @click.stop="handleEdit(row,index)">
            编辑
          </el-button>
          <el-button type="danger" size="small" icon="el-icon-delete" class="myButton"
                     @click.stop="handleDel(row,index)">
            删除
          </el-button>
        </template>
      </avue-crud>
    </basic-container>
  </div>
</template>

<script>
import {
  fetchList,
  putObj,
  delObj,
  addObj,
  getForecastmanufactor,
  syncStation
} from '@/api/electricfield'
import {tableOption} from '@/const/crud/electricfield'
import {mapGetters} from 'vuex'

export default {
  name: 'electricfield',
  data() {
    return {
      searchForm: {},
      tableData: [],
      modId: '',//备用id
      page: {
        total: 0, // 总页数
        currentPage: 1, // 当前页数
        pageSize: 20 // 每页显示多少条
      },
      tableLoading: false,
      tableOption: tableOption,
      manufactor: [],
      stationCodeList: []
    }
  },
  computed: {
    // ...mapGetters(['permissions']),
    // permissionList() {
    //   return {
    //     addBtn: this.vaildData(this.permissions.idp_electricfield_add, false),
    //     delBtn: this.vaildData(this.permissions.idp_electricfield_del, false),
    //     editBtn: this.vaildData(this.permissions.idp_electricfield_edit, false)
    //   };
    // }
  },
  mounted() {
    this.getForecastmanufactor()
  },
  methods: {
    /*打开表格前的回调函数*/
    beforeOpen(done) {
      const _self = this
      let stationCode = this.findObject(this.tableOption.column, 'stationCode')
      stationCode.rules = [{required: true, validator: _self.checkStationCode, trigger: 'blur'}]
      done()
    },
    checkStationCode(rule, value, callback) {
      if (value == '') {
        callback(new Error('请输入场站编号'))
      } else {
        var s6 = this.tableData
        for (let i = 0; i < s6.length; i++) {
          if (this.modId != s6[i].id) {
            if ((value == s6[i].stationCode)) {
              callback(new Error('场站编号不能重复'))
            }
          }
        }
      }
      callback()
    },
    handleEdit(row, index) {
      this.modId = row.id
      this.$refs.crud.rowEdit(row, index);
    },
    handleDel(row, index) {
      this.$refs.crud.rowDel(row, index);
    },
    getForecastmanufactor() {
      getForecastmanufactor().then(response => {
        this.manufactor = response.data.data
      })
    },
    formatbelongForecastManufactor(row) {
      if (row.belongForecastManufactor !== null) {
        let b = ''
        for (let i = 0; i < this.manufactor.length; i++) {
          if (row.belongForecastManufactor === this.manufactor[i].value) {
            b += this.manufactor[i].label
          }
        }
        return b;
      }
    },
    formatForecastmanufactor(row) {
      if (row.forecastManufactor !== null) {
        const a = row.forecastManufactor.split(',')
        let b = ''
        for (let j = 0; j < a.length; j++) {
          for (let i = 0; i < this.manufactor.length; i++) {
            if (a[j] == this.manufactor[i].value) {
              b += this.manufactor[i].label
            }
          }
          if (j === a.length - 1) {
          } else {
            b += ','
          }
        }
        return b;
      }
    },
    syncStation() {
      syncStation().then(response => {
        this.getList(this.page)
        this.$message.success("同步成功")
      }).catch(res => {
        this.$message.error("同步失败")
      })
    },
    getList(page, params) {
      this.tableLoading = true
      fetchList(Object.assign({
        current: page.currentPage,
        size: page.pageSize
      }, params, this.searchForm)).then(response => {
        this.tableData = response.data.data.records
        this.page.total = response.data.data.total
        this.tableLoading = false
      }).catch(() => {
        this.tableLoading = false
      })
    },
    rowDel: function (row, index) {
      this.$confirm('是否确认删除编号为' + row.stationCode + '的场站？', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function () {
        return delObj(row.id)
      }).then(data => {
        this.$message.success('删除成功')
        this.getList(this.page)
      })
    },
    handleUpdate: function (row, index, done, loading) {
      row.forecastManufactor = row.forecastManufactor.toString()
      putObj(row).then(data => {
        this.$message.success('修改成功')
        done()
        this.getList(this.page)
      }).catch(() => {
        loading();
      });
    },
    handleSave: function (row, done, loading) {
      row.forecastManufactor = row.forecastManufactor.toString()
      addObj(row).then(data => {
        this.$message.success('添加成功')
        done()
        this.getList(this.page)
      }).catch(() => {
        loading();
      });
    },
    sizeChange(pageSize) {
      this.page.pageSize = pageSize
    },
    currentChange(current) {
      this.page.currentPage = current
    },
    searchChange(form, done) {
      this.searchForm = form
      this.page.currentPage = 1
      this.getList(this.page, form)
      done()
    },
    refreshChange() {
      this.getList(this.page)
    }
  }
}
</script>
<style scoped>
.myButton {
  color: #409EFF;
  border: none;
  background: transparent
}
</style>
